--libs
sti = require "libs/sti"
bump = require "libs/bump"
require "libs/text"
TableSave = require "libs/TableSave"
moonshine = require "libs/moonshine"
--entities
require "entities/player"
--states
Splash = require "states/splash"
Main_menu = require "states/mainmenu"
About = require "states/about"
Settings = require "states/settings"
Blank = require "states/Blank"
PlayM = require "states/playmenu"
--levels
Tutorial = require "states/levels/tutorial"
--Set State
state = Tutorial

function love.load()
	--Configs
  saves = {
    tuto = false
  }
  if love.filesystem.getInfo("Saves.sav") then 
    saves = loadstring(love.filesystem.read("Saves.sav"))()
  else 
    love.filesystem.write("Saves.sav",table.serialize(saves,true,true))
  end
	Configs = {
    --mod = false, --True or False
    --dir = nil, --StringForm
    --modname = nil, --StringForm
    resolutionW = {1280,1366,1400,1920},
    resolutionH = {720,768,900,1080},
    fullscreen = false,
    crt = false,
    scanlines = false,
    mobilescr = true,
    tcontrol = false,
		statistics = false,
		FPScounter = false,
		windowW = 1280,
		windowH = 720
	}
  FW, FH = love.window.getDesktopDimensions()
    if love.filesystem.getInfo("Configs.sav") then 
        Configs = loadstring(love.filesystem.read("Configs.sav"))()
      else 
        love.filesystem.write("Configs.sav",table.serialize(Configs,true,true))
    end
    if Configs.fullscreen == true then 
      love.window.setMode(FW,FH,{fullscreen = Configs.fullscreen})
    else
      love.window.setMode(Configs.windowW,Configs.windowH)
    end
    --love.window.setMode(Configs.windowW,Configs.windowH)
    if Configs.mobilescr == true then
      Configs.windowW, Configs.windowH = FW, FH
      love.window.setMode(Configs.windowW,Configs.windowH,{fullscreen = true})
    else
    end
	lg = love.graphics
  effect = moonshine(moonshine.effects.crt).chain(moonshine.effects.scanlines)
  effect.resize(Configs.windowW,Configs.windowH)
  lg.setDefaultFilter("nearest","nearest")
	state.load()
  DPI = love.window.getDPIScale()
end
function love.draw()
  lg.setBlendMode("screen")
  lg.scale(scaleX,scaleY)
  effect(function ()
      state.draw()
      lg.origin()
    end)
  lg.print(tostring(scaleX),10,10)
  lg.print(tostring(scaleY),10,20)
end
function love.update(dt)
    if Configs.mobilescr == true then
      if Configs.fullscreen == false then
        Configs.fullscreen = true
      end
    end
  OsX = Configs.windowW/1280
  OsY = Configs.windowH/720
  scaleX = OsX/DPI 
  scaleY = OsY/DPI
  moonshine.effects.crt = {
    scaleFactor = {scaleX,scaleY}
  }
  moonshine.effects.scanlines = {
    thickness = Configs.windowH/144
  }
    if Configs.mobilescr == true then
      Configs.fullscreen = true 
    end
    if Configs.scanlines == false then
      effect.disable("scanlines")
    else
      effect.enable("scanlines")
    end
    if Configs.crt == false then
      effect.disable("crt")
    else
    effect.enable("crt")
    end
	state.update(dt)
end
function love.mousepressed(x,y,button)
	state.mousepressed(x,y,button)
end
function love.mousereleased(x,y,button)
	state.mousereleased(x,y,button)
end
function love.touchpressed(id,x,y)
    if Configs.tcontrol == true then
      state.touchpressed(id,x,y) 
    end
end
function love.touchreleased(id,x,y)
    if Configs.tcontrol == true then
      state.touchreleased(id,x,y)
    end
end
function love.keypressed(k)
	state.keypressed(k)
end
function love.keyreleased(k)
	state.keyreleased(k)
end
function switchState(newState)
	state.exit()
	state = newState
	state.load()
end
function boundary(x,y,x1,y1,w1,h1)
	return x > x1 and
	x < x1 + w1 and
	y > y1 and 
	y < y1 + h1
end